/*
 * This file is part of SpongeAPI, licensed under the MIT License (MIT).
 *
 * Copyright (c) SpongePowered <https://www.spongepowered.org>
 * Copyright (c) contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package org.spongepowered.api.world.gamerule;

/**
 * An enumeration of all possible GameRule names in vanilla minecraft.
 */
public class DefaultGameRules {

    public static final String COMMAND_BLOCK_OUTPUT = "commandBlockOutput";
    public static final String DO_DAYLIGHT_CYCLE = "doDaylightCycle";
    public static final String DO_ENTITY_DROPS = "doEntityDrops";
    public static final String DO_FIRE_TICK = "doFireTick";
    public static final String DO_MOB_LOOT = "doMobLoot";
    public static final String DO_MOB_SPAWNING = "doMobSpawning";
    public static final String DO_TILE_DROPS = "doTileDrops";
    public static final String KEEP_INVENTORY = "keepInventory";
    public static final String LOG_ADMIN_COMMANDS = "logAdminCommands";
    public static final String MOB_GRIEFING = "mobGriefing";
    public static final String NATURAL_REGENERATION = "naturalRegeneration";
    public static final String RANDOM_TICK_SPEED = "randomTickSpeed";
    public static final String REDUCED_DEBUG_INFO = "reducedDebugInfo";
    public static final String SEND_COMMAND_FEEDBACK = "sendCommandFeedback";
    public static final String SHOW_DEATH_MESSAGES = "showDeathMessages";

}
